<?php


namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Contracts\Support\Renderable;

use App\Models\BoycottCompany;
use Illuminate\Http\Request;
use Inertia\Inertia;
use App\Traits\UploadTrait;
class BoycottCompanyController extends Controller
{

    /**
 * Display a listing of the resource.
 * @return Renderable
 */
use UploadTrait;
// use boycott_companieservice;
public function __construct(){
    $this->middleware('permission:boycott_companies-create', ['only' => ['create','store']]);
    $this->middleware('permission:boycott_companies-update',   ['only' => ['edit','update']]);
    $this->middleware('permission:boycott_companies-read',   ['only' => ['show', 'index']]);
    $this->middleware('permission:boycott_companies-delete',   ['only' => ['destroy']]);
    $this->middleware('permission:boycott_companies-eye',   ['only' => ['eye']]);
}
public function eye($id)
{
    $active = BoycottCompany::find($id);
    if ($active->active == 1) {$active->active = 0;} else {$active->active = 1;}$active->save();
    // return $active->active;
    return response()->json(["success" => true, "eye" => $active], 200);
}
public function index(Request $request)
{
    $per_page = $request->itemsPerPage ?? 20;
    $orderBy = $request->sortBy ?? "id";
    $orderDir = $request->sortDesc ?? "desc";
   $boycott_companies = BoycottCompany::orderBy($orderBy, $orderDir)
        ->filter($request->only('search'))
        ->paginate($per_page)
        ->appends(['search' => $request->only('search')]);
    if ($request->wantsJson()) {
        return $boycott_companies;
    }
    return Inertia::render("Admin/BoycottCompany/Index", ["boycott_companies" => $boycott_companies]);
}

/**
 * Show the form for creating a new resource.
 * @return Renderable
 */
public function create()
{

    return Inertia::render("Admin/BoycottCompany/Create");
}

/**
 * Store a newly created resource in storage.
 * @param Request $request
 * @return Renderable
 */
public function store(Request $request)
{

    // dd($request);
    $request->validate([
        'name' => 'required|string|unique:boycott_companies,name',
        'image'         => 'required',
    ]);
    $boycott_companies = new BoycottCompany();
    // $boycott_companies->user_id =auth()->user()->id;
    $boycott_companies->name = $request->name;
    $boycott_companies->name_en = $request->name_en;
    $boycott_companies->details = $request->details;
    $boycott_companies->details_en = $request->details_en;
    $boycott_companies->reason_boycott = $request->reason_boycott;
    $boycott_companies->reason_boycott_en = $request->reason_boycott_en;
    $boycott_companies->image =$this->storeImage($request['image'],'images/boycott_companies');
    $boycott_companies->save();
    return redirect()->route("boycott_companies.index")->with('success', 'تم اضافة  بنجاح');
}

/**
 * Show the specified resource.
 * @param int $id
 * @return Renderable
 */
public function show($id)
{

}

/**
 * Show the form for editing the specified resource.
 * @param int $id
 * @return Renderable
 */
public function edit($id)
{
    $boycott_companies =  BoycottCompany::find($id);
    return Inertia::render("Admin/BoycottCompany/Edit", ["boycott_companies" => $boycott_companies]);
}

/**
 * Update the specified resource in storage.
 * @param Request $request
 * @param int $id
 * @return Renderable
 */
public function update2(Request $request)
{
    // dd($request);
    $request->validate([
    'name'     => 'required|string|unique:boycott_companies,name,'.$request->id,
//     'image'    => 'required',
    ]);
    $boycott_companies =  BoycottCompany::find($request->id);
    // $boycott_companies->user_id   = auth()->user()->id;
    $boycott_companies->name = $request->name;
    $boycott_companies->name_en = $request->name_en;
    $boycott_companies->details = $request->details;
    $boycott_companies->details_en = $request->details_en;
    $boycott_companies->reason_boycott = $request->reason_boycott;
    $boycott_companies->reason_boycott_en = $request->reason_boycott_en;

    if($request['image'] != null)
    $boycott_companies->image =$this->updateImage($request['image'],'images/boycott_companies',$boycott_companies->image);
    $boycott_companies->save();

    return redirect()->route("boycott_companies.index")->with('success', 'تم التعديل   بنجاح');
}

/**
 * Remove the specified resource from storage.
 * @param int $id
 * @return Renderable
 */
public function destroy($id)
{
$boycott_companies= BoycottCompany::find($id);
$this->deleteImage($boycott_companies->image);
$boycott_companies->delete();
return true;
}
}
