<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\CalendarTepyan;
use Illuminate\Http\Request;

use Inertia\Inertia;
use App\Traits\UploadTrait;
class CalendarTepyanController extends Controller
{

    /**
     * Display a listing of the resource.
     * @return Renderable
     */
    use UploadTrait;
    // use calendar_tepyanservice;
    public function __construct()
    {
        $this->middleware('permission:calendar_tepyans-create', ['only' => ['create', 'store']]);
        $this->middleware('permission:calendar_tepyans-update',   ['only' => ['edit', 'update']]);
        $this->middleware('permission:calendar_tepyans-read',   ['only' => ['show', 'index']]);
        $this->middleware('permission:calendar_tepyans-delete',   ['only' => ['destroy']]);
        $this->middleware('permission:calendar_tepyans-eye',   ['only' => ['eye']]);
    }
    public function eye($id)
    {
        $active = CalendarTepyan::find($id);
        if ($active->active == 1) {
            $active->active = 0;
        } else {
            $active->active = 1;
        }
        $active->save();
        // return $active->active;
        return response()->json(["success" => true, "eye" => $active], 200);
    }
    public function index(Request $request)
    {
        $per_page = $request->itemsPerPage ?? 20;
        $orderBy = $request->sortBy ?? "id";
        $orderDir = $request->sortDesc ?? "desc";
        $calendar_tepyans = CalendarTepyan::orderBy($orderBy, $orderDir)
            ->filter($request->only('search'))
            ->paginate($per_page)
            ->appends(['search' => $request->only('search')]);
        if ($request->wantsJson()) {
            return $calendar_tepyans;
        }
        return Inertia::render("Admin/CalendarTepyan/Index", ["calendar_tepyans" => $calendar_tepyans]);
    }

    /**
     * Show the form for creating a new resource.
     * @return Renderable
     */
    public function create()
    {

        $calendar_tepyans =  CalendarTepyan::all();
        return Inertia::render("Admin/CalendarTepyan/Create", ["calendar_tepyans" => $calendar_tepyans]);
    }

    /**
     * Store a newly created resource in storage.
     * @param Request $request
     * @return Renderable
     */
    public function store(Request $request)
    {

        // dd($request);
        $request->validate([
           'daym' => 'required|integer',
            'monthm' => 'required',
            'yearm' => 'required|integer',
            'season' => 'required|integer',
            'dayhim' => 'required|integer',
            'monthhim' => 'required',
            'daysun' => 'required|integer',
            'monthsun' => 'required',
            'dayzs' => 'required|integer',
            'monthzs' => 'required',
            'dayzh' => 'required|integer',
            'monthzh' => 'required',
            // 'day_of_week' => 'required|integer',
        ]);



    // daym
    // monthm
    // yearm
    // season
    // dayhim
    // monthhim
    // daysun
    // monthsun
    // dayzs
    // monthzs
    // dayzh
    // monthzh
    // day_of_week
        $calendar_tepyans = new CalendarTepyan();
        // $calendar_tepyans->user_id = auth()->user()->id;
        $calendar_tepyans->daym = $request->daym;
        $calendar_tepyans->monthm = $request->monthm;
        $calendar_tepyans->yearm = $request->yearm;
        $calendar_tepyans->season = $request->season;
        $calendar_tepyans->dayhim = $request->dayhim;
        $calendar_tepyans->monthhim = $request->monthhim;
        $calendar_tepyans->daysun = $request->daysun;
        $calendar_tepyans->monthsun = $request->monthsun;
        $calendar_tepyans->dayzs = $request->dayzs;
        $calendar_tepyans->monthzs = $request->monthzs;
        $calendar_tepyans->dayzh = $request->dayzh;
        $calendar_tepyans->monthzh = $request->monthzh;
        $calendar_tepyans->day_of_week = $request->day_of_week;
        $calendar_tepyans->save();
        return redirect()->route("calendar_tepyans.index")->with('success', 'تم اضافة  بنجاح');
    }
    /**
     * Show the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function show($id)
    {
    }

    /**
     * Show the form for editing the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function edit($id)
    {
        $calendar_tepyans =  CalendarTepyan::find($id);
        return Inertia::render("Admin/CalendarTepyan/Edit", ["calendar_tepyans" => $calendar_tepyans]);
    }

    /**
     * Update the specified resource in storage.
     * @param Request $request
     * @param int $id
     * @return Renderable
     */
    public function update(Request $request, $id)
    {
        $request->validate([
            'name'     => 'required|string|unique:calendar_tepyans,name,' . $id,
            'order'    => 'required|integer',
            'image'    => 'required',
        ]);
        $calendar_tepyans =  CalendarTepyan::find($id);
        // $calendar_tepyans->user_id   = auth()->user()->id;
        $calendar_tepyans->name      = $request->name;
        $calendar_tepyans->order     = $request->order;
        if ($request['image'] != null)
            $calendar_tepyans->image = $this->updateImage($request['image'], 'images/calendar_tepyans', $calendar_tepyans->image);
        $calendar_tepyans->save();
        return redirect()->route("calendar_tepyans.index")->with('success', 'تم التعديل   بنجاح');
    }

    /**
     * Remove the specified resource from storage.
     * @param int $id
     * @return Renderable
     */
    public function destroy($id)
    {
        $calendar_tepyans = CalendarTepyan::find($id);
        $this->deleteImage($calendar_tepyans->image);
        $calendar_tepyans->delete();
        return true;
    }
}
