<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Location;
use Illuminate\Http\Request;

use Inertia\Inertia;
use App\Traits\UploadTrait;

class LocationController extends Controller
{


    /**
 * Display a listing of the resource.
 * @return Renderable
 */
use UploadTrait;
// use locationservice;
public function __construct(){
    $this->middleware('permission:locations-create', ['only' => ['create','store']]);
    $this->middleware('permission:locations-update',   ['only' => ['edit','update']]);
    $this->middleware('permission:locations-read',   ['only' => ['show', 'index']]);
    $this->middleware('permission:locations-delete',   ['only' => ['destroy']]);
    $this->middleware('permission:locations-eye',   ['only' => ['eye']]);
}
public function eye($id)
{
    $active = Location::find($id);
    if ($active->active == 1) {$active->active = 0;} else {$active->active = 1;}$active->save();
    // return $active->active;
    return response()->json(["success" => true, "eye" => $active], 200);
}
public function index(Request $request)
{
    $per_page = $request->itemsPerPage ?? 20;
    $orderBy = $request->sortBy ?? "id";
    $orderDir = $request->sortDesc ?? "desc";
   $locations = Location::orderBy($orderBy, $orderDir)
        ->filter($request->only('search'))
        ->paginate($per_page)
        ->appends(['search' => $request->only('search')]);
    if ($request->wantsJson()) {
        return $locations;
    }
    return Inertia::render("Admin/Location/Index", ["locations" => $locations]);
}

/**
 * Show the form for creating a new resource.
 * @return Renderable
 */
public function create()
{
    return Inertia::render("Admin/Location/Create");
}

/**
 * Store a newly created resource in storage.
 * @param Request $request
 * @return Renderable
 */
public function store(Request $request)
{

    // dd($request);
    $request->validate([
        'name' => 'required|string|unique:locations,name',
    ]);


    // name
    // name_en
    // code
    // latitude
    // longitude

    $locations = new Location();
    // $locations->user_id =auth()->user()->id;
    $locations->name = $request->name;
    $locations->name_en = $request->name_en;
    $locations->code = $request->code;
    $locations->latitude = $request->latitude;
    $locations->longitude = $request->longitude;
    $locations->save();
    return redirect()->route("locations.index")->with('success', 'تم اضافة  بنجاح');
}

/**
 * Show the specified resource.
 * @param int $id
 * @return Renderable
 */
public function show($id)
{

}

/**
 * Show the form for editing the specified resource.
 * @param int $id
 * @return Renderable
 */
public function edit($id)
{
    $locations =  Location::find($id);

    return Inertia::render("Admin/Location/Edit", ["locations" => $locations]);
}

/**
 * Update the specified resource in storage.
 * @param Request $request
 * @param int $id
 * @return Renderable
 */
public function update(Request $request,$id)
{
    $request->validate([
      'name'     => 'required|string|unique:locations,name,'.$id,

    ]);
    $locations =  Location::find($id);
    // $locations->user_id   = auth()->user()->id;
    $locations->name = $request->name;
    $locations->name_en = $request->name_en;
    $locations->code = $request->code;
    $locations->latitude = $request->latitude;
    $locations->longitude = $request->longitude;

    $locations->save();
    return redirect()->route("locations.index")->with('success', 'تم التعديل   بنجاح');
}

/**
 * Remove the specified resource from storage.
 * @param int $id
 * @return Renderable
 */
public function destroy($id)
{
$locations= Location::find($id);
$this->deleteImage($locations->image);
$locations->delete();
return true;
}
}
