<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
// use Illuminate\Contracts\Support\Renderable;
use App\Models\Phrases;
use App\Models\Category;
use Inertia\Inertia;
use App\Traits\UploadTrait;

class PhrasesController extends Controller
{


        /**
     * Display a listing of the resource.
     * @return Renderable
     */
    use UploadTrait;
   // use phraseservice;
    public function __construct(){
        $this->middleware('permission:phrases-create', ['only' => ['create','store']]);
        $this->middleware('permission:phrases-update',   ['only' => ['edit','update']]);
        $this->middleware('permission:phrases-read',   ['only' => ['show', 'index']]);
        $this->middleware('permission:phrases-delete',   ['only' => ['destroy']]);
        $this->middleware('permission:phrases-eye',   ['only' => ['eye']]);
    }
    public function eye($id)
    {
        $active = Phrases::find($id);
        if ($active->active == 1) {$active->active = 0;} else {$active->active = 1;}$active->save();
        // return $active->active;
        return response()->json(["success" => true, "eye" => $active], 200);
    }
    public function index(Request $request)
    {
        $per_page = $request->itemsPerPage ?? 20;
        $orderBy = $request->sortBy ?? "id";
        $orderDir = $request->sortDesc ?? "desc";
       $phrases = Phrases::orderBy($orderBy, $orderDir)
            ->filter($request->only('search'))
            ->paginate($per_page)
            ->appends(['search' => $request->only('search')]);
        if ($request->wantsJson()) {
            return $phrases;
        }
        return Inertia::render("Admin/Phrases/Index", ["phrases" => $phrases]);
    }

    /**
     * Show the form for creating a new resource.
     * @return Renderable
     */
    public function create()
    {
        return Inertia::render("Admin/Phrases/Create");
    }

    public function gitPhrases($id)
    {
        $gitsubcategories =  Phrases::where('category_id',$id)->get();
        return response()->json(["success" => true, "gitsubcategories" => $gitsubcategories], 200);
    }
    /**
     * Store a newly created resource in storage.
     * @param Request $request
     * @return Renderable
     */
    public function store(Request $request)
    {

    // title
    // title_en
    // details
    // details_en
    // said
    // said_en
    // show_before
    // show_hijris
    // day
    // month
    // show_alert
    // show_alert_time_in

    // dd($request);
        $request->validate([
            // 'name' => 'required|string|unique:phrases,name',
            // 'title' => 'required',
            'details'         => 'required',
            'day'         => 'required|integer',
            'month'         => 'required|integer',
        ]);
        $phrases = new Phrases();
        // $phrases->user_id =auth()->user()->id;
        $phrases->title = $request->title;
        $phrases->title_en = $request->title_en;
        $phrases->said = $request->said;
        $phrases->said_en = $request->said_en;
        $phrases->details = $request->details;
        $phrases->details_en = $request->details_en;
        $phrases->show_before = $request->show_before;
        $phrases->show_hijris = $request->show_hijris;
        $phrases->day = $request->day;
        $phrases->month = $request->month;
        $phrases->show_alert = $request->show_alert;
        $phrases->show_alert_time_in = $request->show_alert_time_in;
        // $phrases->image =$this->storeImage($request['image'],'images/phrases');
        $phrases->save();
        return redirect()->route("phrases.index")->with('success', 'تم اضافة  بنجاح');
    }

    /**
     * Show the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function show($id)
    {

    }

    /**
     * Show the form for editing the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function edit($id)
    {
        $phrases =  Phrases::find($id);
        return Inertia::render("Admin/Phrases/Edit", ["phrases" => $phrases]);
    }

    /**
     * Update the specified resource in storage.
     * @param Request $request
     * @param int $id
     * @return Renderable
     */
    public function update(Request $request,$id)
    {
        $request->validate([
            // 'title' => 'required',
            'details'         => 'required',
            'day'         => 'required|integer',
            'month'         => 'required|integer',
        ]);
        $phrases =  Phrases::find($id);
        // $phrases->user_id   = auth()->user()->id;

        $phrases->title = $request->title;
        $phrases->title_en = $request->title_en;
        $phrases->said = $request->said;
        $phrases->said_en = $request->said_en;
        $phrases->details = $request->details;
        $phrases->details_en = $request->details_en;
        $phrases->show_before = $request->show_before;
        $phrases->show_hijris = $request->show_hijris;
        $phrases->day = $request->day;
        $phrases->month = $request->month;
        $phrases->show_alert = $request->show_alert;
        $phrases->show_alert_time_in = $request->show_alert_time_in;




        $phrases->save();
        return redirect()->route("phrases.index")->with('success', 'تم التعديل   بنجاح');
    }

    /**
     * Remove the specified resource from storage.
     * @param int $id
     * @return Renderable
     */
    public function destroy($id)
    {
    $phrases= Phrases::find($id);
    $this->deleteImage($phrases->image);
    $phrases->delete();
    return true;
    }
}
