<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Contracts\Support\Renderable;
use App\Models\Slider;
use Inertia\Inertia;
use App\Traits\UploadTrait;
class SliderController extends Controller
{
      /**
     * Display a listing of the resource.
     * @return Renderable
     */
    use UploadTrait;
   // use sliderservice;
    public function __construct(){
        $this->middleware('permission:sliders-create', ['only' => ['create','store']]);
        $this->middleware('permission:sliders-update',   ['only' => ['edit','update']]);
        $this->middleware('permission:sliders-read',   ['only' => ['show', 'index']]);
        $this->middleware('permission:sliders-delete',   ['only' => ['destroy']]);
        $this->middleware('permission:sliders-eye',   ['only' => ['eye']]);
    }
    public function eye($id)
    {
        $active = Slider::find($id);
        if ($active->active == 1) {$active->active = 0;} else {$active->active = 1;}$active->save();
        return response()->json(["success" => true, "eye" => $active], 200);
    }
    public function index(Request $request)
    {
        $per_page = $request->itemsPerPage ?? 20;
        $orderBy = $request->sortBy ?? "id";
        $orderDir = $request->sortDesc ?? "desc";
        $sliders = Slider::orderBy($orderBy, $orderDir)->filter($request->only('search'))
       ->paginate($per_page)->appends(['search' => $request->only('search')]);
        if ($request->wantsJson()) {
            return $sliders;
        }

        return Inertia::render("Admin/Slider/Index", ["sliders" => $sliders]);
    }

    /**
     * Show the form for creating a new resource.
     * @return Renderable
     */
    public function create()
    {
        return Inertia::render("Admin/Slider/Create");
    }

    /**
     * Store a newly created resource in storage.
     * @param Request $request
     * @return Renderable
     */
    public function store(Request $request)
    {
     //     title
//     title_en
//     url
//     details
//     details_en
//     date_start
//     date_end
//     time_start
//     time_end
        $request->validate([
            'title' => 'required',
            'details'         => 'required',
            'date_start'         => 'required',
            'date_end'         => 'required',
            'time_start'         => 'required',
            'time_end'         => 'required',
        ]);

        $sliders = new Slider();
     //    $sliders->user_id =auth()->user()->id;
        $sliders->title = $request->title;
        $sliders->title_en = $request->title_en;
        $sliders->details = $request->details;
        $sliders->details_en = $request->details_en;
     //    $sliders->url = $request->url;
        $sliders->date_start = $request->date_start;
        $sliders->date_end = $request->date_end;
        $sliders->time_start = $request->time_start;
        $sliders->time_end = $request->time_end;
        $sliders->save();
        return redirect()->route("sliders.index")->with('success', 'تم اضافة  بنجاح');

      //  return view('slidermodule::Admin.Slider.create');
    }

    /**
     * Show the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function show($id)
    {

    }

    /**
     * Show the form for editing the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function edit($id)
    {

        $sliders =  Slider::find($id);
        return Inertia::render("Admin/Slider/Edit", ["sliders" => $sliders]);
    }

    /**
     * Update the specified resource in storage.
     * @param Request $request
     * @param int $id
     * @return Renderable
     */
    public function update(Request $request, $id)
    {
        $request->validate([
          'title' => 'required',
          'details'         => 'required',
          'date_start'         => 'required',
          'date_end'         => 'required',
          'time_start'         => 'required',
          'time_end'         => 'required',
        ]);
        $sliders =  Slider::find($id);
     //    $sliders->user_id =auth()->user()->id;
        $sliders->title = $request->title;
        $sliders->title_en = $request->title_en;
        $sliders->details = $request->details;
        $sliders->details_en = $request->details_en;
        $sliders->url = $request->url;
        $sliders->date_start = $request->date_start;
        $sliders->date_end = $request->date_end;
        $sliders->time_start = $request->time_start;
        $sliders->time_end = $request->time_end;
        $sliders->save();
        return redirect()->route("sliders.index")->with('success', 'تم التعديل   بنجاح');
    }

    /**
     * Remove the specified resource from storage.
     * @param int $id
     * @return Renderable
     */
    public function destroy($id)
    {
        $categories= Slider::find($id);
        $this->deleteImage($categories->image);
        $categories->delete();
        return true;
    }
}
