<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class BoycottProduct extends Model
{
    use HasFactory;
    
    protected $hidden = ['deleted_at', 'created_at', 'updated_at'];

    public function scopeFilter($query, array $filters)
    {
        $query->when($filters['search'] ?? null, function ($query, $search) {
            $query->where(function ($query) use ($search) {
                $query->where('id', 'like', '%' . $search . '%')
                   ->orWhere('name', 'like', '%' . $search . '%')
                    ;
            });
        });
    }

    public function Hasboycott_category()
    {
        return $this->belongsTo('App\Models\BoycottCategory', 'boycott_categories_id');
    }
    public function Hasboycott_company()
    {
        return $this->belongsTo('App\Models\BoycottCompany', 'boycott_companies_id');
    }
}
