<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Location extends Model
{
    use HasFactory;

    protected $hidden = ['deleted_at', 'created_at', 'updated_at'];
    public function Prayer_time()
    {
        return $this->hasMany('App\Models\Prayer_time');
    }
    public function scopeFilter($query, array $filters)
    {
        $query->when($filters['search'] ?? null, function ($query, $search) {
            $query->where(function ($query) use ($search) {
                $query->where('id', 'like', '%' . $search . '%')
                   ->orWhere('name', 'like', '%' . $search . '%')
                    ;
            });
        });
    }
    
}
