<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateBoycottProductsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */

    // boycott_companies_id
    // boycott_categories_id
    // name
    // details
    // reason_boycott
    // name_en
    // details_en
    // reason_boycott_en
    // qr_code
    // pr_code
    // image

    public function up()
    {
        Schema::create('boycott_products', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger('boycott_companies_id');
            $table->foreign('boycott_companies_id')->references('id')->on('boycott_companies')->onDelete('cascade');
            $table->unsignedBigInteger('boycott_categories_id');
            $table->foreign('boycott_categories_id')->references('id')->on('boycott_categories')->onDelete('cascade');
            $table->string('name');
            $table->string('details')->nullable();
            $table->string('reason_boycott')->nullable();
            $table->string('name_en')->nullable();
            $table->string('details_en')->nullable();
            $table->string('reason_boycott_en')->nullable();
            $table->string('qr_code')->nullable();
            $table->string('pr_code')->nullable();
            $table->string('image')->nullable();
            $table->boolean('active')->default(1);
            $table->softDeletes();
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('boycott_products');
    }
}
